	data	1024
id	equ	0
gross	equ	4
scradr	equ	8
rnd	equ	12
xst	equ	16
yst	equ	18
xe	equ	20
ye	equ	22
xres	equ	24
yres	equ	26
richt	equ	28
succ	equ	30
xpos	equ	32
ypos	equ	34
schritt	equ	36
jid	equ	40
mst	equ	44
stack	equ	48
pid	equ	52
nstack	equ	56
mazenr	equ	60
puffer	equ	128

	bra.s	start
	dc.b	'Ralf'
	dc.w	$4afb
	dc.w	namee-names
names:	dc.b	'3-D Maze'
namee:
* systemvariablen bestimmen
start:	moveq	#0,d0
	trap	#1
	move.l	a0,a4
	tst.l	d1
	bne.s	start0
	moveq	#-19,d0
	rts
* modus auf monitor setzen
start0:	moveq	#$10,d0
	moveq	#-1,d1
	moveq	#-1,d2
	trap	#1
	tst.w	d1
	beq.s	start1
	moveq	#$10,d0
	moveq	#0,d1
	moveq	#0,d2
	trap	#1
start1:	moveq	#$18,d0
	move.l	#512,d1
	moveq	#-1,d2
	trap	#1
	tst.w	d0
	bne	exit
	move.l	a0,a5
* systemvariablen bestimmen
	moveq	#0,d0
	trap	#1
	move.l	a0,a4
* screenadresse bestimmen
	move.l	#$20000,scradr(a5)
	move.w	#128,xres(a5)
	move.w	#256,yres(a5)
* fenster oeffnen
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	lea	con,a0
	trap	#2
	tst.w	d0
	bne	exit1
	move.l	a0,id(a5)
	move.l	a0,pid(a5)
	bsr	help
again:	moveq	#$20,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	atext,a1
	bsr	tout
	bsr	zinput
* speicherplatzreservieren
	lsr.w	#1,d1
	lsl.w	#1,d1
	cmp.w	#6,d1
	blt.s	again
	move.w	d1,gross(a5)
	addq.w	#1,d1
	mulu	d1,d1
	add.l	#1024,d1
	moveq	#$18,d0
	moveq	#-1,d2
	trap	#1
	tst.w	d0
	bne.s	again
	lea	512(a0),a0
	move.l	a0,mst(a5)
	moveq	#$20,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	mtext,a1
	bsr	tout
	bsr	zinput
	tst.w	d1
	bne.s	m1
	moveq	#$13,D0
	trap	#1
m1:	and.l	#$ffff,d1
	move.l	d1,rnd(a5)
	move.l	d1,mazenr(a5)
* maske darstellen
	bsr	scrinit
* maze erzeugen
	bsr	minit
	move.w	xst(a5),xpos(a5)
	move.w	yst(a5),ypos(a5)
* clock starten
weiter:	moveq	#1,d0
	moveq	#-1,d1
	moveq	#120,d2
	moveq	#120,d3
	sub.l	a1,a1
	trap	#1
	move.l	d1,jid(a5)
	move.w	#$4ef9,(a0)+
	lea	clock,a1
	move.l	a1,(a0)+
	move.w	#$4afb,(a0)+
	move.w	#5,(a0)+
	move.l	#'Cloc',(a0)+
	move.w	#'k ',(a0)+
	moveq	#10,d0
	moveq	#1,d2
	moveq	#0,d3
	trap	#1	
	moveq	#$f,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
* hauptschleife
mloop:	bsr	mdraw
	bsr	key 
	tst.w	succ(a5)
	bne	erfolg
	cmp.b	#'Q',d1
	beq	exit4
	cmp.b	#'P',d1
	beq	printer
	cmp.b	#'S',d1
	bne.s	mloop1
	bsr	screen
	bsr	scrinit
	bra	weiter
mloop1:	cmp.b	#'A',d1
	beq	auto
	cmp.b	#'N',d1
	beq.s	new
	cmp.b	#'H',d1
	bne	mloop
	bsr	help
	bsr	scrinit
	bsr	mdraw
	bra	mloop
new:	moveq	#$19,d0
	move.l	mst(a5),a0
	lea	-512(a0),a0
	trap	#1
	moveq	#5,d0
	move.l	jid(a5),d1
	moveq	#0,d3
	trap	#1
	bra	again

* hilfe ausgeben
help:	moveq	#$20,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	htext,a1
	bsr	tout
	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	rts

* maze automatisch loesen
auto:	lea	autext,a1
	bsr	tout
	moveq	#$18,d0
	move.l	#$10000,d1
	moveq	#-1,d2
	trap	#1
	tst.w	d0
	bne.s	aul1
	move.l	a0,nstack(a5)
	move.l	a7,stack(a5)
	move.l	a0,a7
	add.l	#$10000,a7
	move.l	#$F00,d7
	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	moveq	#-1,d2
	clr.w	$8a(a4)
	bsr	recurs
erecurs:move.l	stack(a5),a7
	moveq	#$19,d0
	move.l	nstack(a5),a0
	trap	#1
	moveq	#5,d0
	move.l	jid(a5),d1
	moveq	#0,d3
	trap	#1
	lea	stext,a1
	bsr	tout
aul0:	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	bclr	#5,d1
        cmp.b	#'N',d1
	beq.s	aul1
	cmp.b	#'Y',d1
	bne.s	aul0
	move.l	id(a5),a0
	moveq	#$2d,d0
	moveq	#0,d1
	moveq	#0,d2
	trap	#3
	bsr	screen
aul1:	lea	ntext,a1
	bsr	tout
aul2:	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	bclr	#5,d1
        cmp.b	#'N',d1
	beq	exit2
	cmp.b	#'Y',d1
	bne.s	aul2
	moveq	#$19,d0
	move.l	mst(a5),a0
	lea	-512(a0),a0
	trap	#1
	bra	again
	
* maze recursiv loesen
recurs:	tst.b	$8b(a4)
	bne	erecurs
	subq.l	#1,d7
	beq	erecurs
	bsr	test
	tst.b	d5
	beq.s	recurs0
	cmp.b	#3,d5
	beq	erecurs
	addq.l	#1,d7
	rts
recurs0:pea	0(a0,d3.l)
	st	0(a0,d3.l)		* flag
	move.w	d0,xpos(a5)
	move.w	d1,ypos(a5)
	move.w	d2,richt(a5)
	move.w	d2,-(sp)
	bsr	goa
	bsr	mrichta
	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	movem.w	d0/d1,-(sp)
	move.l	d7,-(sp)
	bsr	mdraw
	move.l	(sp)+,d7
	moveq	#2,d2
	movem.w	(sp),d0/d1
	addq.w	#1,d0
	bsr	recurs
	movem.w	(sp),d0/d1
	moveq	#1,d2
	subq.w	#1,d1
	bsr	recurs
	movem.w	(sp),d0/d1
	moveq	#3,d2
	addq.w	#1,d1
	bsr	recurs
	movem.w	(sp),d0/d1
	moveq	#0,d2
	subq.w	#1,d0
	bsr	recurs
	movem.w	(sp)+,d0/d1
	addq.l	#1,d7
	move.w	(sp)+,d2
	eor.b	#2,d2
	move.w	d2,richt(a5)
	move.w	d0,xpos(a5)
	move.w	d1,ypos(a5)
	bsr	goa
	bsr	mrichta
	move.l	d7,-(sp)
	bsr	mdraw
	move.l	(sp)+,d7
	move.l	(sp)+,a0
	move.b	#$fe,(a0)
	rts

* maze geloest      
erfolg:	moveq	#$19,d0
	move.l	mst(a5),a0
	lea	-512(a0),a0
	trap	#1
	moveq	#5,d0
	move.l	jid(a5),d1
	moveq	#0,d3
	trap	#1
	lea	etext,a1
	bsr	tout
	lea	stext,a1
	bsr	tout
erf0:	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	bclr	#5,d1
        cmp.b	#'N',d1
	beq.s	erf1
	cmp.b	#'Y',d1
	bne.s	erf0
	move.l	id(a5),a0
	moveq	#$2d,d0
	moveq	#0,d1
	moveq	#0,d2
	trap	#3
	bsr	screen
	lea	ntext,a1
	bsr	tout
erf1:	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	bclr	#5,d1
        cmp.b	#'N',d1
	beq.s	exit2
	cmp.b	#'Y',d1
	beq	again
	bra.s	erf1

* ausgabe auf bildschirm
screen:	moveq	#5,d0
	move.l	jid(a5),d1
	moveq	#0,d3
	trap	#1
        moveq	#$20,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	move.l	a0,pid(a5)
	trap	#3
	bsr	output
	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	rts

* ausgabe auf printer
printer:moveq	#5,d0
	move.l	jid(a5),d1
	moveq	#0,d3
	trap	#1
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	lea	prn,a0
	trap	#2
	move.l	a0,pid(a5)
	bsr	output
	moveq	#2,d0
	move.l	pid(a5),a0
	trap	#2
	bsr	scrinit
	bra	weiter

exit4:	moveq	#5,d0
	move.l	jid(a5),d1
	moveq	#0,d3
	trap	#1
exit3:	moveq	#$19,d0
	move.l	mst(a5),a0
	lea	-512(a0),a0
	trap	#1
exit2:	move.l	id(a5),a0
	moveq	#2,d0
	trap	#2
exit1:	moveq	#$19,d0
	move.l	a5,a0
	trap	#1
exit:	moveq	#5,d0
	moveq	#-1,d1
	moveq	#0,d3
	trap	#1
	moveq	#0,d0
	rts

* zahl eingeben
zinput:	moveq	#2,d0
	moveq	#5,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	lea	puffer(a5),a1
	trap	#3
	moveq	#4,d7
	moveq	#0,d1
	lea	puffer(a5),a1
	moveq	#0,d0
ziloop: move.b	(a1)+,d0
	sub.b	#'0',d0
	bmi.s	eziloop
	cmp.b	#9,d0
	bhi.s	eziloop
	mulu    #10,d1
	add.w	d0,d1
	dbra	d7,ziloop
eziloop:rts

* job der die uhr anzeigt
clock:	lea	0(a6,a4.l),a5
* fenster oeffnen
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	lea	con,a0
	trap	#2
	move.l	a0,id(a5)
	moveq	#$13,d0
	trap	#1
	move.l	d1,d7
clockl:	moveq	#$13,d0
	trap	#1
	move.l	d1,d0
	sub.l	d7,d0
        lea	9(a5),a0
	moveq	#4,d2
	bsr	dez
	moveq	#$10,d0
	moveq	#75,d1
	moveq	#5,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	moveq	#7,d0
	moveq	#5,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	lea	4(a5),a1
	trap	#3
	moveq	#8,d0
	moveq	#-1,d1
	moveq	#50,d3
	sub.l	a1,a1
	trap	#1
	bra.s   clockl

* tastatur abfragen
key:	moveq	#1,d0
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	cmp.b	#'a',d1
	blt.s	key1
	cmp.b	#'z',d1
	bhi.s	key1
	bclr	#5,d1
key1:	cmp.b	#192,d1
	bne.s	key2
	move.w	richt(a5),d0
	subq.w	#1,d0
	bra.s	mricht
key2:	cmp.b	#200,d1
	bne.s	key3
        move.w	richt(a5),d0
	addq.w	#1,d0
        bra.s	mricht
key3:	cmp.b	#208,d1
	bne.s	key4
	moveq	#1,d2
	bra	go
key4:	cmp.b	#216,d1
	bne.s	key5
        moveq	#-1,d2
	bra	go
key5:	cmp.b	#'Q',d1
	beq.s	ekey
	cmp.b	#'A',d1
	beq.s	ekey
	cmp.b	#'N',d1
	beq.s	ekey
	cmp.b	#'P',d1
	beq.s	ekey
	cmp.b	#'S',d1
	beq.s	ekey
	cmp.b	#'H',d1
	bne.s	key
ekey:	rts

* richtung anzeigen
mricht:	and.w	#3,d0
	move.w	d0,richt(a5)
mrichta:moveq	#$10,d0
	moveq	#80,d1
	moveq	#11,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	moveq	#5,d0
	moveq	#'',d1
	move.w	richt(a5),d2
	beq.s	mricht0
	cmp.b	#1,d2
	bne.s	mricht1
	moveq	#'',d1
	bra.s	mricht0
mricht1:cmp.b	#2,d2
	bne.s	mricht2
	moveq	#'',d1
	bra.s	mricht0
mricht2:moveq	#'',d1
mricht0:moveq	#-1,d3
	trap	#3
	addq.l	#1,schritt(a5)
	bsr	zugout
	moveq	#$10,d0
	moveq	#80,d1
	moveq	#17,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	rts
	
* in richtung gehen
go:	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	move.w	richt(a5),d3
	bne.s	go1
        sub.w	d2,d0
	bra.s	ego
go1:	cmp.w	#1,d3
	bne.s	go2
	sub.w	d2,d1
	bra.s	ego
go2:	cmp.w	#2,d3
	bne.s	go3
	add.w	d2,d0
	bra.s	ego
go3:	add.w	d2,d1
ego:	bsr	test
	cmp.b	#$ff,d5
	beq.s	ego1
	tst.b	d5
	bne	gotit
ego1:	move.w	d0,xpos(a5)
	move.w	d1,ypos(a5)
	addq.l	#1,schritt(a5)
	move.l	mst(a5),a0
	move.w	gross(a5),d3
	addq.w	#1,d3
	mulu	d1,d3
	add.l	d0,d3
	st	0(a0,d3.l)		* flag
	bsr	zugout
goa:	moveq	#$10,d0
	moveq	#80,d1
	moveq	#17,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	moveq	#$24,d0
	moveq	#-1,d3
	trap	#3
	moveq	#$10,d0
	moveq	#80,d1
	moveq	#17,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
nfrei0:	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	subq.w	#1,d0
	bsr	test
	tst.b	d5
	beq.s	frei0
	cmp.b	#-1,d5
	bne.s	nfrei1
frei0:	moveq	#5,d0
	moveq	#'',d1
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
nfrei1:	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	addq.w	#1,d0
	bsr	test
	tst.b	d5
	beq.s	frei1
	cmp.b	#-1,d5
	bne.s	nfrei2
frei1:	moveq	#5,d0
	moveq	#'',d1
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
nfrei2:	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	addq.w	#1,d1
	bsr	test
	tst.b	d5
	beq.s	frei2
	cmp.b	#-1,d5
	bne.s	nfrei3
frei2:	moveq	#5,d0
	moveq	#'',d1
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
nfrei3:	move.w	xpos(a5),d0
	move.w	ypos(a5),d1
	subq.w	#1,d1
	bsr	test
	tst.b	d5
	beq.s	frei3
	cmp.b	#-1,d5
	bne.s	nfrei4
frei3:	moveq	#5,d0
	moveq	#'',d1
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
nfrei4:	moveq	#$10,d0
	moveq	#70,d1
	moveq	#15,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	puffer+4(a5),a0
	moveq	#3,d2
	move.w	xpos(a5),d0
	bsr	dez
	moveq	#7,d0
	moveq	#4,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	lea	puffer(a5),a1
	trap	#3
	moveq	#$10,d0
	moveq	#77,d1
	moveq	#15,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	puffer+4(a5),a0
	moveq	#3,d2
	move.w	ypos(a5),d0
	bsr	dez
	moveq	#7,d0
	moveq	#4,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	lea	puffer(a5),a1
	trap	#3
	rts
gotit:	cmp.b	#3,d5
	beq	goaus
	bsr	ton
	bra	key

goaus:	bsr	ton1
	not.w	succ(a5)
	rts	

* anzahl der zuege ausgeben
zugout:	moveq	#$10,d0
	moveq	#75,d1
	moveq	#8,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	puffer+5(a5),a0
	moveq	#4,d2
	move.l	schritt(a5),d0
	bsr	dez
	moveq	#7,d0
	moveq	#5,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	lea	puffer(a5),a1
	trap	#3
        rts

* testoutput
output:	move.l	pid(a5),a0
	moveq	#$20,d0
	moveq	#-1,d3
	trap	#3
	move.l	mst(a5),a2
	move.w	gross(a5),d7
outl1:	move.w	gross(a5),d6
outl2:	moveq	#' ',d1
	move.b	(a2)+,d2
	beq.s   outl3
	cmp.b	#$fe,d2
	beq.s	outl3
	moveq	#'+',d1
	cmp.b	#1,d2
	beq.s	outl3
	moveq	#'E',d1
	cmp.b	#2,d2
	beq.s	outl3
	moveq	#'A',d1
	cmp.b	#3,d2
	beq.s	outl3
	moveq	#$29,d0
	moveq	#7,d1
	moveq	#-1,d3
	move.l	pid(a5),a0
	trap	#3
	moveq	#'.',d1
outl3:	moveq	#5,d0
	moveq	#-1,d3
	trap	#3
	moveq	#$29,d0
	moveq	#4,d1
	moveq	#-1,d3
	move.l	pid(a5),a0
	trap	#3
	dbra	d6,outl2
	moveq	#5,d0
	move.b	#10,d1
	moveq	#-1,d3
	trap	#3
	dbra	d7,outl1
	rts

* maze darstellen
mdraw:	bsr	mclr
	moveq	#4,d7			* fuenf ebenen
	moveq	#0,d6			* nummer der ebene
        move.w	xpos(a5),d0		* x-koordinate
	move.w	ypos(a5),d1             * y-koordinate
	move.w	richt(a5),d2
	bne	mdraw1
* mitte finden
mdl1:	subq.w	#1,d0
	bsr	test
	bsr	drawm
	cmp.b	#1,d5
	beq.s	emdl1
	cmp.b	#2,d5
	beq.s	emdl1
	cmp.b	#3,d5
	beq.s	emdl1
* links finden
	addq.w	#1,d1
	bsr	test
	bsr	drawl
* rechts finden
	subq.w	#2,d1
	bsr	test
	bsr	drawr
	addq.w	#1,d1
	addq.w	#1,d6
	dbra	d7,mdl1
	lea	muf,a0
	bsr	drawit
emdl1:	rts
mdraw1:	cmp.w	#1,d2
	bne	mdraw2
* mitte finden
mdl2:	subq.w	#1,d1
	bsr	test
	bsr	drawm
	cmp.b	#1,d5
	beq.s	emdl2
	cmp.b	#2,d5
	beq.s	emdl2
	cmp.b	#3,d5
	beq.s	emdl2
* links finden
	subq.w	#1,d0
	bsr	test
	bsr	drawl
* rechts finden
	addq.w	#2,d0
	bsr	test
	bsr	drawr
	subq.w	#1,d0
	addq.w	#1,d6
	dbra	d7,mdl2
	lea	muf,a0
	bsr	drawit
emdl2:	rts
mdraw2:	cmp.w	#2,d2
	bne	mdraw3
* mitte finden
mdl3:	addq.w	#1,d0
	bsr	test
	bsr	drawm
	cmp.b	#1,d5
	beq.s	emdl3
	cmp.b	#2,d5
	beq.s	emdl3
	cmp.b	#3,d5
	beq.s	emdl3
* links finden
	subq.w	#1,d1
	bsr	test
	bsr	drawl
* rechts finden
	addq.w	#2,d1
	bsr	test
	bsr	drawr
	subq.w	#1,d1
	addq.w	#1,d6
	dbra	d7,mdl3
	lea	muf,a0
	bsr	drawit
emdl3:	rts
* mitte finden
mdraw3:	addq.w	#1,d1
	bsr	test
	bsr	drawm
	cmp.b	#1,d5
	beq.s	emdl4
	cmp.b	#2,d5
	beq.s	emdl4
	cmp.b	#3,d5
	beq.s	emdl4
* links finden
	addq.w	#1,d0
	bsr	test
	bsr	drawl
* rechts finden
	subq.w	#2,d0
	bsr	test
	bsr	drawr
	addq.w	#1,d0
	addq.w	#1,d6
	dbra	d7,mdraw3
	lea	muf,a0
	bsr	drawit
emdl4:	rts

* testen ob d0,d1 belegt
test:	move.l	mst(a5),a0
	move.w	gross(a5),d3
	addq.w	#1,d3
	mulu	d1,d3
	add.l	d0,d3
	move.b	0(a0,d3.l),d5		* flag
	rts

* mitte zeichnen
drawm:	move.w	d5,-(a7)
	lea	mb,a0
	moveq	#50,d4
	cmp.b	#1,d5
	beq.s	drawm1
	cmp.b	#2,d5
	beq.s	drawm1
	lea	ma,a0
	cmp.b	#3,d5
	beq.s	drawm1
	lea	mf,a0
	moveq	#34,d4
drawm1:	mulu	d6,d4
	add.l	d4,a0
	bsr	drawit
	move.w	(a7)+,d5
	tst.b	d5
	rts

* links zeichnen
drawl:	moveq	#50,d4
	lea	la,a0
	cmp.b	#3,d5
	beq.s	drawl1
	moveq	#18,d4
	lea	lb,a0
	cmp.b	#1,d5
	beq.s	drawl1
	cmp.b	#2,d5
	beq.s	drawl1
	lea	lf,a0
	moveq	#34,d4
drawl1:	mulu	d6,d4
	add.l	d4,a0
	bsr	drawit
	rts

* rechts zeichnen
drawr:	moveq	#50,d4
	lea	ra,a0
	cmp.b	#3,d5
	beq.s	drawr1
	moveq	#18,d4
	lea	rb,a0
	cmp.b	#1,d5
	beq.s	drawr1
	cmp.b	#2,d5
	beq.s	drawr1
	lea	rf,a0
	moveq	#34,d4
drawr1:	mulu	d6,d4
	add.l	d4,a0
	bsr	drawit
	rts

* zeichnen
drawit:	movem.l	d0/d1/d6/d7,-(sp)
	move.w	(a0)+,d7
drloop: movem.w	(a0)+,d0/d1/d2/d3
	movem.l	a0/d7,-(sp)
	bsr	line
	movem.l	(sp)+,a0/d7
	dbra	d7,drloop
	movem.l	(sp)+,d0/d1/d6/d7
	rts

* mazedarstellung loeschen
mclr:	move.l	scradr(a5),a0
	lea	100(a0),a0
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d4
	moveq	#0,d6
	move.w	xres(a5),d6
	move.w	#199,d7
mclrl:	move.l	a0,a1
	movem.l	d0-d4,-(a1)
	movem.l	d0-d4,-(a1)
	movem.l	d0-d4,-(a1)
	movem.l	d0-d4,-(a1)
	movem.l	d0-d4,-(a1)
	add.l	d6,a0
	dbra	d7,mclrl
	rts

* bildschirm initialisieren
* bildschirm loeschen 
scrinit:move.l	scradr(a5),a0
	move.w	yres(a5),d7
	mulu	xres(a5),d7
scrclr: clr.b	(a0)+
	subq.l	#1,d7
	bne.s	scrclr
* rahmen ziehen
	move.w	#400,d0
	moveq	#0,d1
	move.w	#400,d2
	move.w	#200,d3
	bsr	line
	moveq	#0,d0
	move.w	#200,d1
	move.w	#400,d2
	move.w	#200,d3
	bsr	line
	lea	gtext,a1
	bsr	tout
	lea	text1,a1
	bsr	tout
	lea	text2,a1
	bsr	tout
	lea	text3,a1
	bsr	tout
	lea	text4,a1
	bsr	tout
	lea	text5,a1
	bsr	tout
	lea	text6,a1
	bsr	tout
	lea	text7,a1
	bsr	tout
	lea	text8,a1
	bsr	tout
	lea	text10,a1
	bsr	tout
	lea	text12,a1
	bsr	tout
* maze bestimmen
	move.w	#1,richt(a5)
	clr.w	succ(a5)
	clr.l	schritt(a5)
	moveq	#$10,d0
	moveq	#75,d1
	moveq	#2,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	trap	#3
	lea	puffer+5(a5),a0
	moveq	#4,d2
	move.l	mazenr(a5),d0
	bsr	dez
	moveq	#7,d0
	moveq	#5,d2
	moveq	#-1,d3
	move.l	id(a5),a0
	lea	puffer(a5),a1
	trap	#3
	rts

* maze erzeugen
* maze loeschen
minit:	move.l	mst(a5),a0
	move.w	gross(a5),d7
	addq.w	#1,d7
	mulu	d7,d7
	subq.l	#1,d7
mil1:	clr.b	(a0)+
	subq.l	#1,d7
	bne.s	mil1
* raender setzen
	move.l	mst(a5),a0
	move.w	gross(a5),d7
	addq.w	#1,d7
	mulu	d7,d7
	lea	0(a0,d7.l),a1
	move.w	gross(a5),d7
mil2:	move.b	#1,(a0)+
	move.b	#1,-(a1)
	dbra	d7,mil2
	subq.l	#1,a1
	moveq	#0,d6
	move.w	gross(a5),d7
	move.w	d7,d6
	addq.w	#1,d6
	subq.w	#2,d7
mil3:	move.b	#1,(a0)
	move.b	#1,(a1)
	add.l	d6,a0
	sub.l	d6,a1
	dbra	d7,mil3
* maze ausfuellen
	moveq	#0,d1		* y
	move.w	gross(a5),d5	* breite
	move.l	mst(a5),a0	* adresse
	move.w	d5,d7
	addq.w	#1,d5
	lsr.w	#2,d7
mil4:   move.w	gross(a5),d6
	lsr.w	#1,d6
	moveq	#0,d0		* x
mil5:	move.w	d1,d2
	mulu	d5,d2
	add.l	d0,d2
	tst.b	0(a0,d2.l)	* besetzt ?
	beq.s	emil5
        cmp.b	#1,0(a0,d2.l)	* mauer ?
	bne.s	emil5
	bsr	mwall
emil5:	addq.l	#2,d0		* x=x+2
	dbra	d6,mil5
	addq.l	#2,d1		* y=y+2
	dbra	d7,mil4
	subq.l	#1,d1
	move.w	#1,xst(a5)
	move.w	d1,yst(a5)
	move.w	gross(a5),xe(a5)
	move.w	d1,ye(a5)	
	moveq	#0,d0
	move.w	gross(a5),d0
	move.w	d1,d2
	mulu	d5,d2
	move.b	#2,0(a0,d2.l)	* eingang
	add.l	d0,d2
	move.b	#3,0(a0,d2.l)	* ausgang
	move.w	gross(a5),d1	* y
	move.w	d5,d7
	lsr.w	#2,d7
mil6:   move.w	gross(a5),d6
	lsr.w	#1,d6
	moveq	#0,d0		* x
mil7:	move.w	d1,d2
	mulu	d5,d2
	add.l	d0,d2
	tst.b	0(a0,d2.l)	* besetzt ?
	beq.s	emil7
        cmp.b	#1,0(a0,d2.l)	* mauer ?
	bne.s	emil7
	bsr	mwall
emil7:	addq.l	#2,d0		* x=x+2
	dbra	d6,mil7
	subq.l	#2,d1		* y=y+2
	dbra	d7,mil6
        rts

* von einem punkt eine mauer ziehen
mwall:	movem.l	d0/d1/d5/d6/d7/a0,-(a7)
	and.l	#$ffff,d0
	and.l	#$ffff,d1
        moveq	#0,d7
mwalll1:moveq	#4,d3
	bsr	random
mwalll:	addq.w	#1,d7
	tst.w	d3
	bne.s	mwall1
        move.l	d0,d3
	subq.l	#2,d3
	bmi	emwalll
	move.l	d1,d2
	mulu	d5,d2
	add.l	d3,d2
	tst.b	0(a0,d2.l)
	bne	emwalll
	move.b	#1,0(a0,d2.l)
	subq.l	#1,d0
	move.l	d1,d2
	mulu	d5,d2
	add.l	d0,d2
	move.b	#1,0(a0,d2.l)
	subq.l	#1,d0
	bra	emwalll
mwall1:	cmp.w	#1,d3
	bne.s	mwall2
        move.l	d0,d3
	addq.l	#2,d3
	cmp.w	d5,d3
	bge	emwalll
	move.l	d1,d2
	mulu	d5,d2
	add.l	d3,d2
	tst.b	0(a0,d2.l)
	bne	emwalll
	move.b	#1,0(a0,d2.l)
	addq.l	#1,d0
	move.l	d1,d2
	mulu	d5,d2
	add.l	d0,d2
	move.b	#1,0(a0,d2.l)
	addq.l	#1,d0
	bra	emwalll
mwall2:	cmp.w	#2,d3
	bne.s	mwall3
        move.l	d1,d2
	subq.l	#2,d2
	bmi	emwalll
	mulu	d5,d2
	add.l	d0,d2
	tst.b	0(a0,d2.l)
	bne	emwalll
	move.b	#1,0(a0,d2.l)
	subq.l	#1,d1
	move.l	d1,d2
	mulu	d5,d2
	add.l	d0,d2
	move.b	#1,0(a0,d2.l)
	subq.l	#1,d1
	bra	emwalll
mwall3:	move.l	d1,d2
	addq.l	#2,d2
	cmp.l	d5,d2
	bge	emwalll
	mulu	d5,d2
	add.l	d0,d2
	tst.b	0(a0,d2.l)
	bne	emwalll
	move.b	#1,0(a0,d2.l)
	addq.l	#1,d1
	move.l	d1,d2
	mulu	d5,d2
	add.l	d0,d2
	move.b	#1,0(a0,d2.l)
	addq.l	#1,d1
emwalll:cmp.w	#10,d7
	beq	emwall
	move.w	d3,d6
	moveq	#3,d3
	bsr	random
	move.w	d3,d2
	move.w	d6,d3
	tst.w	d2
	beq	mwalll1
	bra	mwalll
emwall:	movem.l	(a7)+,d0/d1/d5/d6/d7/a0
	rts

*D0 in ASCII umwandeln
dez     divu    #10,d0
        swap    d0
        add.b   #'0',d0
        move.b  d0,-(a0)
        clr.b   d0
        swap    d0
        dbra    d2,dez
        rts

* zufallszahlen erzeugen
RANDOM  MOVEQ   #1,D2
        OR.L    rnd(A5),D2
        MOVE.L  D2,D4
        MULU    #$163,D2
        SWAP    D4
        MULU    #$163,D4
        SWAP    D4
        CLR.W   D4
        ADD.L   D4,D2
        MOVE.L  D2,rnd(A5)
        SWAP    D2
        MULU    D2,D3
        SWAP    D3
        RTS

*EXTREM SCHNELLE LINE-ROUTINE BITTE BEACHTEN
*FALLS SCHNELLERE BEKANNT BITTE MELDEN
*D0 = X-KOORDINATE PUNKT 1
*D1 = Y-KOORDINATE PUNKT 1
*D2 = X-KOORDINATE PUNKT 2
*D3 = Y-KOORDIANTE PUNKT 2
line	moveq	#-1,d6
        MOVE.L  scradr(A5),A1   *START BILDSPEICHER
        SUB.W   D0,D2           *DELTA X
        BEQ     VL1             *VERTIKALE LINIE
        MOVE.W  D0,D5           *X NACH D5
        AND.W   #7,D5           *FUER FARBMASKE
        LSR.W   #3,D0           *8 BITSPALTEN PRO WORTSPALTE
        LSL.W   #1,D0           *NUR GERADE ADRESSEN
        ADD.W   D0,A1           *STARTADRESSE DER SPALTE
        MOVE.W  XRES(A5),D4
        SUB.W   D1,D3           *DELTA Y
        BEQ     HL1             *DELTA Y = 0 HORIZONTALE LINIE
        BPL.S   MST2            *POSITIVE STEIGUNG
        NEG.W   D3              *DELTA Y = -DELTA Y
        NEG.W   D4              *NEGATIVE STEIGUNG
MST2    MOVE.W  #$8080,D0       *BITMASKE FUER FARBE WEISS
        ROR.W   D5,D0           *BITMASKE FUER LINIENANFANG
        MULU    XRES(A5),D1     *STARTZEILE * ZEILENLAENGE
        ADD.L   D1,A1           *STARTADRESSE FUER ZEILE
        CMP.W   D2,D3           * X- ODER Y-RICHTUNG
        BEQ     DLINE           *DIAGONALE
        BGT     YL              *Y-RICHTUNG
*X-RICHTUNG
        MOVE.W  D2,D7
        NEG.W   D7              *FLAG VORBEREITEN
        ASR.W   #1,D7
        MOVE.W  D2,D5
        MOVE.W  D0,D1           *BITMASKE
        ROR.W   #1,D0           *NAECHSTE SPALTE
        BCS.S   LAB13           *NAECHSTE WORTSPALTE
        DBRA    D5,LAB11
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKTE SETZEN
        RTS
LAB11   ADD.W   D3,D7           *FLAG TESTEN
        BPL.S   LAB14
        OR.W    D0,D1           *PUNKTMASKE
LAB12   ROR.W   #1,D0           *NAECHSTE SPALTE
        BCS.S   LAB13           *NAECHSTE WORTSPALTE
        DBRA    D5,LAB11
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKTE SETZEN
        RTS
LAB13   NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)+        *PUNKTE SETZEN
        MOVEQ   #0,D1
        DBRA    D5,LAB11
        RTS
LAB14   NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKTE SETZEN
        MOVE.W  D0,D1           *BITMASKE
        ADD.W   D4,A1           *NAECHSTE ZEILE
        SUB.W   D2,D7           *FLAG
        ROR.W   #1,D0           *NAECHSTE SPALTE
        BCS.S   LAB13           *NAECHSTE WORTSPALTE
        DBRA    D5,LAB11
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKTE SETZEN
        RTS
*DIAGONALE
DLINE   MOVE.W  D0,D1
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKT SETZEN
        ADD.W   D4,A1           *NAECHSTE ZEILE
        ROR.W   #1,D0           *NAECHSTE PUNKTSPALTE
        BCS.S   LAB21           *NAECHSTE WORTSPALTE
        DBRA    D2,DLINE
        RTS
LAB21   ADDQ.W  #2,A1           *NAECHSTE WORTSPALTE
        DBRA    D2,DLINE
        RTS  
*Y-RICHTUNG
YL      MOVE.W  D3,D7           *FLAG VORBEREITEN
        ASR.W   #1,D7
        MOVE.W  D3,D5
        MOVE.W  D0,D1
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKT SETZEN
        ADD.W   D4,A1           *NAECHSTE ZEILE
        DBRA    D5,LAB31
        RTS
LAB31   SUB.W   D2,D7           *FLAG TESTEN
        BMI.S   LAB33
LAB32   MOVE.W  D0,D1
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKT SETZEN
        ADD.W   D4,A1           *NAECHSTE ZEILE
        DBRA    D5,LAB31
        RTS
LAB33   ADD.W   D3,D7           *FLAG
        ROR.W   #1,D0           *NAECHSTE BITSPALTE
        BCC.S   LAB32
        ADDQ.W  #2,A1           *NAECHSTE WORTSPALTE
        MOVE.W  D0,D1
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKT SETZEN
        ADD.W   D4,A1           *NAECHSTE ZEILE
        DBRA    D5,LAB31
        RTS

*ROUTINE FUER HORIZONTALE LINIEN
HL1     MOVE.W  #$8080,D0       *BITMASKE
        ROR.W   D5,D0           *BITMASKE FUER SPALTE
        MULU    XRES(A5),D1     *STARTZEILE * ZEILENLAENGE
        ADD.L   D1,A1           *STARTADRESSE FUER ZEILE
        ADDQ.W  #1,D2
        TST.W   D5              *WORTGRENZE
        BEQ.S   EHL2            *SPECIAL
        SUBQ.W  #1,D2
        MOVEQ   #0,D1           *BITMASKE LOESCHEN
HL1L    OR.W    D0,D1           *BITMASKE AKTUALISIEREN
HL1L1   ROR.W   #1,D0           *BITMASKE FUER SPALTE
        BCS.S   LAB41           *NOCH GLEICHE WORTSPALTE
        DBRA    D2,HL1L         *NAECHSTER PUNKT
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)         *PUNKTE SETZEN
        RTS
LAB41   NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)+        *PUNKTE SETZEN
        BRA.S   EHL2
HL2     MOVE.W  D6,(A1)+        *PUNKTE
EHL2    SUBQ.W  #8,D2           *KEINE WORTGRENZE MEHR
        BPL.S   HL2
LAB52   CMP.W   #-8,D2          *WORTGRENZE
        BEQ.S   ELINE
        ADDQ.W  #7,D2           *LETZTEN RESET
        MOVE.W  #$8080,D0
        MOVE.W  D0,D1
        DBRA    D2,LAB53
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)
ELINE   RTS
LAB53   ROR.W   #1,D0
        OR.W    D0,D1
ELAB53  DBRA    D2,LAB53
        NOT.W   D1
        AND.W   D1,(A1)
        NOT.W   D1
        AND.W   D6,D1
        OR.W    D1,(A1)
        RTS
        
*ROUTINE FUER VERTIKALE LINIEN
VL1     MOVE.W  D0,D5           *X NACH D5
        AND.W   #7,D5           *FUER FARBMASKE
        LSR.W   #3,D0           *8 BITSPALTEN PRO WORTSPALTE
        LSL.W   #1,D0           *NUR GERADE ADRESSEN
        ADD.W   D0,A1           *STARTADRESSE DER SPALTE
        MOVE.W  XRES(A5),D4
        SUB.W   D1,D3           *DELTA Y
        BPL.S   VL2             *POSITIVE STEIGUNG
        NEG.W   D3              *DELTA Y = -DELTA Y
        NEG.W   D4              *NEGATIVE STEIGUNG
VL2     MOVE.W  #$8080,D0       *BITMASKE FUER FARBE WEISS
        ROR.W   D5,D0           *BITMASKE FUER LINIENANFANG
        MULU    XRES(A5),D1     *STARTZEILE * ZEILENLAENGE
        ADD.L   D1,A1           *STARTADRESSE FUER ZEILE
        MOVE.W  D0,D1
        AND.W   D6,D1
        NOT.W   D0
VL1L    AND.W   D0,(A1)
        OR.W    D1,(A1)         *PUNKT SETZEN
        ADD.W   D4,A1           *NAECHSTE ZEILE
        DBRA    D3,VL1L         *NAECHSTER PUNKT
        RTS

con:	dc.w	cone-cons
cons:	dc.b	'CON_512x256a0x0'
cone:
	even

prn:	dc.w	prne-prns
prns:	dc.b	'ser1'
prne:
	even

* text ausgeben
tout:	move.l	id(a5),a0
	moveq	#$2d,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	move.l	a1,-(a7)
	trap	#3
	move.l	(a7)+,a1
	moveq	#$10,d0
	move.w	(a1)+,d1
	move.w	(a1)+,d2
	moveq	#-1,d3
	move.l	a1,-(a7)
	trap	#3
	move.l	(a7)+,a1
	move.w	$d0,a2
	jsr	(a2)
	rts

* ton ausgeben
ton:      LEA       SND_BAD,A3          *BEEP
          MOVEQ	    #$11,D0
          TRAP	    #1
	  RTS

SND_BAD   DC.W      $0A08,$0000
          DC.W      $AAAA,$1E1E
          DC.W      $000A,$000A
          DC.W      $0000,$0100

ton1:     LEA       click,A3          *BEEP
          MOVEQ	    #$11,D0
          TRAP	    #1
	  RTS

click:	dc.b    10,16,$44,$44,$aa,$66
        dc.b    1,0
        dc.b    2,0
        dc.b    148,17
        dc.b    0,255
        dc.b    0,0
        dc.b    5,0
        dc.b    9,0
        dc.b    0,0
        dc.b    1
        even

* texte 
* 1. wort weight
* 2. wort height
* 3. wort x
* 4. wort y
* 5. wort text
text1:	dc.w	3,1,3,11,text1e-text1s
text1s:	dc.b	'3-D Maze by'
text1e:	
	even

text2:	dc.w	0,0,50,23,text2e-text2s
text2s:	dc.b	'Ralf Biedermann'
text2e:	
	even

text3:	dc.w	0,0,70,2,text3e-text3s
text3s:	dc.b	'Maze:'
text3e:	
	even

text4:	dc.w	0,0,70,5,text4e-text4s
text4s:	dc.b	'TIME:'
text4e:	
	even

text5:	dc.w	0,0,70,8,text5e-text5s
text5s:	dc.b	'STEP:'
text5e:	
	even

text6:	dc.w	0,0,70,20,text6e-text6s
text6s:	dc.b	'Steuerung: '
text6e:	
	even

text7:	dc.w	0,0,70,17,text7e-text7s
text7s:	dc.b	'Ausgnge:'
text7e:
	even

text8:	dc.w	0,0,70,23,text8e-text8s
text8s:	dc.b	'Speziell:AHNPQS'
text8e:	
	even

text10:	dc.w	0,0,70,11,text10e-text10s
text10s:dc.b	'Richtung: '
text10e:	
	even

text12:	dc.w	0,0,70,14,text12e-text12s
text12s:dc.b	'X-Pos  Y-Pos'
text12e:	
	even

atext:	dc.w	3,1,4,6,atexte-atexts
atexts:	dc.b	' Size:'
atexte:
	even

mtext:  dc.w	3,1,4,6,mtexte-mtexts
mtexts:	dc.b	'Number:'
mtexte:
	even

etext:  dc.w	3,1,4,5,etexte-etexts
etexts:	dc.b	'CONGRATULATIONS !!!'
etexte:
	even

ntext:  dc.w	3,1,4,7,ntexte-ntexts
ntexts:	dc.b	'Again ? Y/N'
ntexte:
	even

stext:  dc.w	3,1,4,6,stexte-stexts
stexts:	dc.b	'See solution ? Y/N'
stexte:
	even

gtext:  dc.w	3,1,1,6,gtexte-gtexts
gtexts:	dc.b	'One moment please'
gtexte:
	even

autext:	dc.w	0,0,70,2,atexte1-atexts1
atexts1:dc.b	'Auto:'
atexte1:
	even

htext:	dc.w	0,0,0,0,htexte-htexts
htexts:	dc.b	'HELP for 3-D Maze',10
 dc.b 'At the start you will be asked to enter the size of the maze (6..).',10
 dc.b 'The form is square, You will start at the left in the middle.',10
 dc.b 'The finish is at the right in the middle.',10
 dc.b 'Next you will be asked to enter a number. With this number and',10
 dc.b 'and the size of the maze you could generate the same maze',10
 dc.b 'when ever you want (competition?). If you enter 0 a random',10
 dc.b 'maze will be generated.',10
 dc.b 'After you entered both numbers a maze will be generated, a clock',10
 dc.b 'will be started and the game could start.',10
 dc.b 'During play there are the following keys allowed.',10 
 dc.b ' rotate left            rotate right',10
 dc.b ' one step forward       one step backwards',10
 dc.b 'A the programme tries to solve the maze automaticly',10
 dc.b 'H displays this page',10
 dc.b 'N stop current game and start a new one',10
 dc.b 'Q quit the programme',10
 dc.b 'P prints the maze (SER1)',10
 dc.b 'S dumps the maze to screen',10
 dc.b 'Good Luck Ralf Biedermann',10,10
 dc.b 'P.S. the finish is marked with a 45 degree cross.',10
 dc.b 'Please press a key'
htexte:
	even

* tabellen fuer grafiken
* links belegt
lb:	dc.w	1
	dc.w	0*38,0*19,1*38,1*19
	dc.w	0*38,200-0*19,1*38,200-1*19

	dc.w	1
	dc.w	1*38,1*19,2*38,2*19
	dc.w	1*38,200-1*19,2*38,200-2*19

	dc.w	1
	dc.w	2*38,2*19,3*38,3*19
	dc.w	2*38,200-2*19,3*38,200-3*19

	dc.w	1
	dc.w	3*38,3*19,4*38,4*19
	dc.w	3*38,200-3*19,4*38,200-4*19

	dc.w	1
	dc.w	4*38,4*19,5*38-10,5*19-5
	dc.w	4*38,200-4*19,5*38-10,200-5*19+5

* links frei
lf:	dc.w	3
	dc.w	0*38,0*19,1*38,1*19
	dc.w	0*38,200-0*19,1*38,200-1*19
	dc.w	0*38,1*19,1*38,1*19
	dc.w	0*38,200-1*19,1*38,200-1*19

	dc.w	3
	dc.w	1*38,1*19,2*38,2*19
	dc.w	1*38,200-1*19,2*38,200-2*19
	dc.w	1*38,2*19,2*38,2*19
	dc.w	1*38,200-2*19,2*38,200-2*19

	dc.w	3
	dc.w	2*38,2*19,3*38,3*19
	dc.w	2*38,200-2*19,3*38,200-3*19
	dc.w	2*38,3*19,3*38,3*19
	dc.w	2*38,200-3*19,3*38,200-3*19

	dc.w	3
	dc.w	3*38,3*19,4*38,4*19
	dc.w	3*38,200-3*19,4*38,200-4*19
	dc.w	3*38,4*19,4*38,4*19
	dc.w	3*38,200-4*19,4*38,200-4*19

	dc.w	3
	dc.w	4*38,4*19,5*38-10,5*19-5
	dc.w	4*38,200-4*19,5*38-10,200-5*19+5
	dc.w	4*38,5*19-5,5*38-10,5*19-5
	dc.w	4*38,200-5*19+5,5*38-10,200-5*19+5

* links ausgang
la:	dc.w	5
	dc.w	0*38,0*19,1*38,1*19
	dc.w	0*38,200-0*19,1*38,200-1*19
	dc.w	0*38,1*19,1*38,1*19
	dc.w	0*38,200-1*19,1*38,200-1*19
* X
	dc.w	0*38,0*19,1*38,200-1*19
	dc.w	0*38,200-0*19,1*38,1*19

	dc.w	5
	dc.w	1*38,1*19,2*38,2*19
	dc.w	1*38,200-1*19,2*38,200-2*19
	dc.w	1*38,2*19,2*38,2*19
	dc.w	1*38,200-2*19,2*38,200-2*19
* X
	dc.w	1*38,1*19,2*38,200-2*19
	dc.w	1*38,200-1*19,2*38,2*19

	dc.w	5
	dc.w	2*38,2*19,3*38,3*19
	dc.w	2*38,200-2*19,3*38,200-3*19
	dc.w	2*38,3*19,3*38,3*19
	dc.w	2*38,200-3*19,3*38,200-3*19
* X
	dc.w	2*38,2*19,3*38,200-3*19
	dc.w	2*38,200-2*19,3*38,3*19

	dc.w	5
	dc.w	3*38,3*19,4*38,4*19
	dc.w	3*38,200-3*19,4*38,200-4*19
	dc.w	3*38,4*19,4*38,4*19
	dc.w	3*38,200-4*19,4*38,200-4*19
* X
	dc.w	3*38,3*19,4*38,200-4*19
	dc.w	3*38,200-3*19,4*38,4*19

	dc.w	5
	dc.w	4*38,4*19,5*38-10,5*19-5
	dc.w	4*38,200-4*19,5*38-10,200-5*19+5
	dc.w	4*38,5*19-5,5*38-10,5*19-5
	dc.w	4*38,200-5*19+5,5*38-10,200-5*19+5
* X
	dc.w	4*38,4*19,5*38-10,200-5*19+5
	dc.w	4*38,200-4*19,5*38-10,5*19-5

* mitte belegt
mb:	dc.w	5
	dc.w	0*38,0*19,400-0*38,0*19
	dc.w	0*38,0*19,0*38,200-0*19
	dc.w	0*38,200-0*19,400-0*38,200-0*19
	dc.w	400-0*38,0*19,400-0*38,200-0*19
	dc.w	200,0*19,200,200-0*19
	dc.w	0*38,100,400-0*38,100
	
	dc.w	5
	dc.w	1*38,1*19,400-1*38,1*19
	dc.w	1*38,1*19,1*38,200-1*19
	dc.w	1*38,200-1*19,400-1*38,200-1*19
	dc.w	400-1*38,1*19,400-1*38,200-1*19
	dc.w	200,1*19,200,200-1*19
	dc.w	1*38,100,400-1*38,100

	dc.w	5
	dc.w	2*38,2*19,400-2*38,2*19
	dc.w	2*38,2*19,2*38,200-2*19
	dc.w	2*38,200-2*19,400-2*38,200-2*19
	dc.w	400-2*38,2*19,400-2*38,200-2*19
	dc.w	200,2*19,200,200-2*19
	dc.w	2*38,100,400-2*38,100

	dc.w	5
	dc.w	3*38,3*19,400-3*38,3*19
	dc.w	3*38,3*19,3*38,200-3*19
	dc.w	3*38,200-3*19,400-3*38,200-3*19
	dc.w	400-3*38,3*19,400-3*38,200-3*19
	dc.w	200,3*19,200,200-3*19
	dc.w	3*38,100,400-3*38,100

	dc.w	5
	dc.w	4*38,4*19,400-4*38,4*19
	dc.w	4*38,4*19,4*38,200-4*19
	dc.w	4*38,200-4*19,400-4*38,200-4*19
	dc.w	400-4*38,4*19,400-4*38,200-4*19
	dc.w	200,4*19,200,200-4*19
	dc.w	4*38,100,400-4*38,100

* mitte frei
mf:	dc.w	3
	dc.w	0*38,0*19,400-0*38,0*19
	dc.w	0*38,0*19,0*38,200-0*19
	dc.w	0*38,200-0*19,400-0*38,200-0*19
	dc.w	400-0*38,0*19,400-0*38,200-0*19

	dc.w	3
	dc.w	1*38,1*19,400-1*38,1*19
	dc.w	1*38,1*19,1*38,200-1*19
	dc.w	1*38,200-1*19,400-1*38,200-1*19
	dc.w	400-1*38,1*19,400-1*38,200-1*19

	dc.w	3
	dc.w	2*38,2*19,400-2*38,2*19
	dc.w	2*38,2*19,2*38,200-2*19
	dc.w	2*38,200-2*19,400-2*38,200-2*19
	dc.w	400-2*38,2*19,400-2*38,200-2*19

	dc.w	3
	dc.w	3*38,3*19,400-3*38,3*19
	dc.w	3*38,3*19,3*38,200-3*19
	dc.w	3*38,200-3*19,400-3*38,200-3*19
	dc.w	400-3*38,3*19,400-3*38,200-3*19

	dc.w	3
	dc.w	4*38,4*19,400-4*38,4*19
	dc.w	4*38,4*19,4*38,200-4*19
	dc.w	4*38,200-4*19,400-4*38,200-4*19
	dc.w	400-4*38,4*19,400-4*38,200-4*19

* mitte ausgang
ma:	dc.w	5
	dc.w	0*38,0*19,400-0*38,0*19
	dc.w	0*38,0*19,0*38,200-0*19
	dc.w	0*38,200-0*19,400-0*38,200-0*19
	dc.w	400-0*38,0*19,400-0*38,200-0*19
* X
	dc.w	0*38,0*19,400-0*38,200-0*19
	dc.w	0*38,200-0*19,400-0*38,0*19
	
	dc.w	5
	dc.w	1*38,1*19,400-1*38,1*19
	dc.w	1*38,1*19,1*38,200-1*19
	dc.w	1*38,200-1*19,400-1*38,200-1*19
	dc.w	400-1*38,1*19,400-1*38,200-1*19
* X
	dc.w	1*38,1*19,400-1*38,200-1*19
	dc.w	1*38,200-1*19,400-1*38,1*19

	dc.w	5
	dc.w	2*38,2*19,400-2*38,2*19
	dc.w	2*38,2*19,2*38,200-2*19
	dc.w	2*38,200-2*19,400-2*38,200-2*19
	dc.w	400-2*38,2*19,400-2*38,200-2*19
* X
	dc.w	2*38,2*19,400-2*38,200-2*19
	dc.w	2*38,200-2*19,400-2*38,2*19

	dc.w	5
	dc.w	3*38,3*19,400-3*38,3*19
	dc.w	3*38,3*19,3*38,200-3*19
	dc.w	3*38,200-3*19,400-3*38,200-3*19
	dc.w	400-3*38,3*19,400-3*38,200-3*19
* X
	dc.w	3*38,3*19,400-3*38,200-3*19
	dc.w	3*38,200-3*19,400-3*38,3*19

	dc.w	5
	dc.w	4*38,4*19,400-4*38,4*19
	dc.w	4*38,4*19,4*38,200-4*19
	dc.w	4*38,200-4*19,400-4*38,200-4*19
	dc.w	400-4*38,4*19,400-4*38,200-4*19
* X
	dc.w	4*38,4*19,400-4*38,200-4*19
	dc.w	4*38,200-4*19,400-4*38,4*19

* mitte unendlich frei
muf:	dc.w	3
	dc.w	5*38-10,5*19-5,400-5*38+10,5*19-5
	dc.w	5*38-10,5*19-5,5*38-10,200-5*19+5
	dc.w	5*38-10,200-5*19+5,400-5*38+10,200-5*19+5
	dc.w	400-5*38+10,5*19-5,400-5*38+10,200-5*19+5

* rechts belegt
rb:	dc.w	1
	dc.w	400-1*38,1*19,400-0*38,0*19
	dc.w	400-1*38,200-1*19,400-0*38,200-0*19

	dc.w	1
	dc.w	400-2*38,2*19,400-1*38,1*19
	dc.w	400-2*38,200-2*19,400-1*38,200-1*19

	dc.w	1
	dc.w	400-3*38,3*19,400-2*38,2*19
	dc.w	400-3*38,200-3*19,400-2*38,200-2*19

	dc.w	1
	dc.w	400-4*38,4*19,400-3*38,3*19
	dc.w	400-4*38,200-4*19,400-3*38,200-3*19

	dc.w	1
	dc.w	400-5*38+10,5*19-5,400-4*38,4*19
	dc.w	400-5*38+10,200-5*19+5,400-4*38,200-4*19

* rechts frei
rf:	dc.w	3
	dc.w	400-1*38,1*19,400-0*38,0*19
	dc.w	400-1*38,1*19,400-0*38,1*19
	dc.w	400-1*38,200-1*19,400-0*38,200-0*19
	dc.w	400-1*38,200-1*19,400-0*38,200-1*19

	dc.w	3
	dc.w	400-2*38,2*19,400-1*38,1*19
	dc.w	400-2*38,2*19,400-1*38,2*19
	dc.w	400-2*38,200-2*19,400-1*38,200-1*19
	dc.w	400-2*38,200-2*19,400-1*38,200-2*19

	dc.w	3
	dc.w	400-3*38,3*19,400-2*38,2*19
	dc.w	400-3*38,3*19,400-2*38,3*19
	dc.w	400-3*38,200-3*19,400-2*38,200-2*19
	dc.w	400-3*38,200-3*19,400-2*38,200-3*19

	dc.w	3
	dc.w	400-4*38,4*19,400-3*38,3*19
	dc.w	400-4*38,4*19,400-3*38,4*19
	dc.w	400-4*38,200-4*19,400-3*38,200-3*19
	dc.w	400-4*38,200-4*19,400-3*38,200-4*19

	dc.w	3
	dc.w	400-5*38+10,5*19-5,400-4*38,4*19
	dc.w	400-5*38+10,5*19-5,400-4*38,5*19-5
	dc.w	400-5*38+10,200-5*19+5,400-4*38,200-4*19
	dc.w	400-5*38+10,200-5*19+5,400-4*38,200-5*19+5

* rechts ausgang
ra:	dc.w	5
	dc.w	400-1*38,1*19,400-0*38,0*19
	dc.w	400-1*38,1*19,400-0*38,1*19
	dc.w	400-1*38,200-1*19,400-0*38,200-0*19
	dc.w	400-1*38,200-1*19,400-0*38,200-1*19
* X
	dc.w	400-1*38,1*19,400-0*38,200-0*19
	dc.w	400-1*38,200-1*19,400-0*38,0*19

	dc.w	5
	dc.w	400-2*38,2*19,400-1*38,1*19
	dc.w	400-2*38,2*19,400-1*38,2*19
	dc.w	400-2*38,200-2*19,400-1*38,200-1*19
	dc.w	400-2*38,200-2*19,400-1*38,200-2*19
* X
	dc.w	400-2*38,2*19,400-1*38,200-1*19
	dc.w	400-2*38,200-2*19,400-1*38,1*19

	dc.w	5
	dc.w	400-3*38,3*19,400-2*38,2*19
	dc.w	400-3*38,3*19,400-2*38,3*19
	dc.w	400-3*38,200-3*19,400-2*38,200-2*19
	dc.w	400-3*38,200-3*19,400-2*38,200-3*19
* X
	dc.w	400-3*38,3*19,400-2*38,200-2*19
	dc.w	400-3*38,200-3*19,400-2*38,2*19

	dc.w	5
	dc.w	400-4*38,4*19,400-3*38,3*19
	dc.w	400-4*38,4*19,400-3*38,4*19
	dc.w	400-4*38,200-4*19,400-3*38,200-3*19
	dc.w	400-4*38,200-4*19,400-3*38,200-4*19
* X
	dc.w	400-4*38,4*19,400-3*38,200-3*19
	dc.w	400-4*38,200-4*19,400-3*38,3*19

	dc.w	5
	dc.w	400-5*38+10,5*19-5,400-4*38,4*19
	dc.w	400-5*38+10,5*19-5,400-4*38,5*19-5
	dc.w	400-5*38+10,200-5*19+5,400-4*38,200-4*19
	dc.w	400-5*38+10,200-5*19+5,400-4*38,200-5*19+5
* X
	dc.w	400-5*38+10,5*19-5,400-4*38,200-4*19
	dc.w	400-5*38+10,200-5*19+5,400-4*38,4*19
		
